<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="编号" prop="codeNo">
        <el-input
          v-model="queryParams.codeNo"
          placeholder="请输入推广码编号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="推广人" prop="userName">
        <el-input
          v-model="queryParams.userName"
          placeholder="请输入推广人名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="推广人手机" prop="userMobile" label-width="6em">
        <el-input
          v-model="queryParams.userMobile"
          placeholder="请输入推广人手机号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="推广角色" prop="userType">
        <el-select v-model="queryParams.userType" placeholder="请选择推广的角色类型" clearable @change="handleQuery">
          <el-option
            v-for="dict in dict.type.user_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
<!--      <el-form-item label="使用者" prop="useUserMobile">-->
<!--        <el-input-->
<!--          v-model="queryParams.useUserMobile"-->
<!--          placeholder="请输入使用者手机号"-->
<!--          clearable-->
<!--          @keyup.enter.native="handleQuery"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['ss:shareCode:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['ss:shareCode:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['ss:shareCode:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="shareCodeList" @selection-change="handleSelectionChange" :default-sort="defaultSort"  @sort-change="onSortChange">
      <el-table-column type="selection" width="55" align="center" />
      <template v-for="column of showColumns">
        <el-table-column
            :key="column.key"
            :label="column.label"
            :prop="column.key"
            :align="column.align"
            :min-width="column.minWidth"
            :sort-orders="orderSorts"
            :sortable="column.sortable"
            :show-overflow-tooltip="column.overflow"
            :width="column.width"
        >
          <template slot-scope="d">
            <template v-if="column.key === 'codeId'">
              {{d.row[column.key]}}
            </template>
            <template v-else-if="column.key === 'userType'">
              <dict-tag :options="dict.type.user_type" :value="d.row[column.key]"/>
            </template>
            <template v-else-if="column.key === 'userId'">
              <user-link :id="d.row.userId" :name="d.row.userName"/>
            </template>
            <template v-else-if="column.key === 'investorId'">
              <user-link :id="d.row.investorId" :name="d.row.investorName"/>
            </template>
            <template v-else-if="column.key === 'qrcode'">
              <el-popover
                placement="top"
                width="180"
                trigger="hover">
                <div class="qr-code-box">
                  <qr-code :text="getShareCodeWxUrl(d.row.codeNo)" :width="150" :height="150" />
                  <p style="text-align: center">推广二维码</p>
                </div>
                <el-button slot="reference" type="text" icon="el-icon-picture">查看</el-button>
              </el-popover>
            </template>
            <template v-else-if="column.key === 'point'">
              {{d.row[column.key] | money | defaultValue}} %
            </template>
            <template v-else-if="column.key === 'surplusPoint'">
              {{computeSurplusPoint(d.row) | money | defaultValue}} %
            </template>
            <template v-else>
              {{d.row[column.key]}}
            </template>
          </template>
        </el-table-column>
      </template>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['ss:shareCode:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['ss:shareCode:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改推广码对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="创建人" prop="userId">
          <user-input
            v-model="form.userId"
            @change="onChangeCreator"
            @load="onLoadCreator"
            :query="{types: [SmUserType.AGENT, SmUserType.BIZ]}"
            show-type
          />
        </el-form-item>
        <el-form-item label="推广角色" prop="userType">
          <el-select v-model="form.userType" placeholder="请选择推广的角色类型" style="width: 100%" @change="onChangeUserType">
            <el-option
              v-for="dict in dict.type.user_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
              :disabled="disabledUserType(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="FieldName.INVESTOR" prop="investorId" v-if="form.userType === SmUserType.BUSINESS_PLACE">
          <user-input
            v-model="form.investorId"
            :placeholder="`请选择推广${FieldName.STORE}绑定的${FieldName.INVESTOR}`"
            :before-open="beforeOpenInvestor"
            :query="investorQuery"
            show-type
            @change="onChangeInvestor"
          />
        </el-form-item>
        <el-form-item label="分成比例" prop="point">
          <el-input-number v-model="form.point" placeholder="请输入分成比例" controls-position="right" :min="0" :max="100" :precision="2" style="width: calc(100% - 1.5em)"/> %
          <div>剩余可分配分成：{{computeSurplusPoint(form) | money | defaultValue}} %</div>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listShareCode, getShareCode, delShareCode, addShareCode, updateShareCode } from "@/api/ss/shareCode";
import { $showColumns } from '@/utils/mixins';
import UserInput from '@/components/Business/SmUser/UserInput.vue'
import { FieldName, SmUserType } from '@/utils/constants'
import UserLink from '@/components/Business/SmUser/UserLink.vue'
import { getShareCodeWxUrl } from '@/utils/wx'
import QrCode from '@/components/QrCode/index.vue'

// 默认排序字段
const defaultSort = {
  prop: "createTime",
  order: "descending"
}

export default {
  name: "ShareCode",
  computed: {
    FieldName() {
      return FieldName
    },
    SmUserType() {
      return SmUserType
    },
    disabledUserType() {
      return (value) => {
        if (value === SmUserType.NORMAL) {
          return true;
        }
        // 代理商
        if (this.creatorUserType === SmUserType.AGENT) {
          return ![SmUserType.AGENT, SmUserType.BIZ].includes(value);
        }
        if (this.creatorUserType === SmUserType.BIZ) {
          return ![SmUserType.BIZ, SmUserType.BUSINESS_PLACE, SmUserType.INVESTOR].includes(value);
        }
        return true;
      }
    },
    // 投资人查询条件
    investorQuery() {
      return {
        type: SmUserType.INVESTOR,
        referenceId: this.form.userId
      }
    },
    // 计算剩余比例
    computeSurplusPoint() {
      return (row) => {
        if (row == null) {
          return 0;
        }
        return (row.userPoint | 0) - (row.point | 0) - (row.investorPoint | 0);
      }
    }
  },
  components: { QrCode, UserLink, UserInput },
  mixins: [$showColumns],
  dicts: ['user_type'],
  data() {
    return {
      creatorUserType: null,  // 创建者的用户类型
      // 字段列表
      columns: [
        {key: 'codeId', visible: true, label: '推广码ID', minWidth: null, sortable: true, overflow: false, align: 'center', width: "100"},
        {key: 'codeNo', visible: true, label: '推广码编号', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'qrcode', visible: true, label: '二维码', minWidth: null, sortable: false, overflow: false, align: 'center', width: "80"},
        {key: 'userId', visible: true, label: '推广人', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'userType', visible: true, label: '推广角色', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'investorId', visible: true, label: FieldName.INVESTOR, minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'point', visible: true, label: '分成比例', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        {key: 'surplusPoint', visible: true, label: '推广人剩余比例', minWidth: null, sortable: false, overflow: false, align: 'center', width: null},
        {key: 'expireTime', visible: true, label: '过期时间', minWidth: "120", sortable: false, overflow: false, align: 'center', width: null},
        // {key: 'status', visible: true, label: '状态', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        // {key: 'useUserMobile', visible: true, label: '使用者', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        // {key: 'useStoreId', visible: false, label: '使用者经营场所', minWidth: null, sortable: true, overflow: false, align: 'center', width: null},
        // {key: 'useTime', visible: true, label: '使用时间', minWidth: "120", sortable: false, overflow: false, align: 'center', width: null},
      ],
      // 排序方式
      orderSorts: ['ascending', 'descending', null],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 推广码表格数据
      shareCodeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      defaultSort,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        orderByColumn: defaultSort.prop,
        isAsc: defaultSort.order,
        codeId: null,
        codeNo: null,
        userId: null,
        userType: null,
        investorId: null,
        status: null,
        useUserId: null,
        useStoreId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        userId: [
          { required: true, message: "创建人不能为空", trigger: "change" }
        ],
        userType: [
          { required: true, message: "推广角色不能为空", trigger: "change" }
        ],
        point: [
          { required: true, type: 'number', message: "分成比例不能为空", trigger: "blur" }
        ],
        investorId: [
          { required: true, message: `${FieldName.STORE}不能为空`, trigger: "change" }
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    onChangeUserType(val) {
      if (val !== SmUserType.BUSINESS_PLACE && this.form.investorId != null) {
        this.form.investorId = null;
        this.onChangeInvestor(null);
      }
    },
    getShareCodeWxUrl,
    beforeOpenInvestor() {
      if (this.form.userId == null) {
        this.$message.warning("请先选择创建人");
        return false;
      }
      return true;
    },
    onLoadCreator(list) {
      if (list != null && list.length > 0) {
        this.creatorUserType = list[0].type;
      }
    },
    onChangeInvestor(user) {
      console.log("onChangeInvestor", user)
      this.form.investorPoint = user?.point;
    },
    onChangeCreator(user) {
      console.log("onChangeCreator", user)
      this.creatorUserType = user?.type;
      this.form.userPoint = user?.point;
      if (this.disabledUserType(this.form.userType)) {
        this.form.userType = null;
      }
      if (this.form.investorId != null) {
        this.form.investorId = null;
        this.form.investorPoint = 0;
        this.$message.info(`由于更换了推广人，请重新选择${FieldName.INVESTOR}`)
      }
    },
    /** 当排序按钮被点击时触发 **/
    onSortChange(column) {
      if (column.order == null) {
        this.queryParams.orderByColumn = defaultSort.prop;
        this.queryParams.isAsc = defaultSort.order;
      } else {
        this.queryParams.orderByColumn = column.prop;
        this.queryParams.isAsc = column.order;
      }
      this.getList();
    },
    /** 查询推广码列表 */
    getList() {
      this.loading = true;
      listShareCode(this.queryParams).then(response => {
        this.shareCodeList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        codeId: null,
        codeNo: null,
        userId: null,
        userType: null,
        point: null,
        investorId: null,
        expireTime: null,
        createTime: null,
        status: null,
        useUserId: null,
        useStoreId: null,
        useTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.codeId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.creatorUserType = null;
      this.open = true;
      this.title = "添加推广码";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.creatorUserType = null;
      const codeId = row.codeId || this.ids
      getShareCode(codeId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改推广码";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.codeId != null) {
            updateShareCode(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addShareCode(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const codeIds = row.codeId || this.ids;
      this.$modal.confirm('是否确认删除推广码编号为"' + codeIds + '"的数据项？').then(function() {
        return delShareCode(codeIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('ss/shareCode/export', {
        ...this.queryParams
      }, `shareCode_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
